/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDataquierLogiccondRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquierLogiccond extends TableImpl<VDataquierLogiccondRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dataquier_logiccond</code>
     */
    public static final VDataquierLogiccond V_DATAQUIER_LOGICCOND = new VDataquierLogiccond();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierLogiccondRecord> getRecordType() {
        return VDataquierLogiccondRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier_logiccond.fk_element</code>.
     */
    public final TableField<VDataquierLogiccondRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_logiccond.logictype_descr</code>.
     */
    public final TableField<VDataquierLogiccondRecord, String> LOGICTYPE_DESCR = createField(DSL.name("logictype_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier_logiccond.fk_orgrp</code>.
     */
    public final TableField<VDataquierLogiccondRecord, Integer> FK_ORGRP = createField(DSL.name("fk_orgrp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier_logiccond.cond</code>.
     */
    public final TableField<VDataquierLogiccondRecord, String> COND = createField(DSL.name("cond"), SQLDataType.CLOB, this, "");

    private VDataquierLogiccond(Name alias, Table<VDataquierLogiccondRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquierLogiccond(Name alias, Table<VDataquierLogiccondRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier_logiccond" as  SELECT l.fk_variable AS fk_element,
          ty.logictype_descr,
          l.fk_orgrp,
          string_agg(((h1.short_name || co.logiccond_comparator) ||
              CASE co.compare_variables
                  WHEN 1 THEN h2.short_name
                  ELSE COALESCE((co.logiccond_value)::text, 'null'::text)
              END), '&'::text) AS cond
         FROM (((((common_dd.t_core_logic l
           LEFT JOIN common_dd.t_core_logictype ty ON ((ty.logictype = l.fk_logictype)))
           LEFT JOIN common_dd.t_core_logicandgrp a_1 ON ((a_1.fk_orgrp = l.fk_orgrp)))
           LEFT JOIN common_dd.t_core_logiccond co ON ((co.fk_andgrp = a_1.andgrp)))
           LEFT JOIN common_dd.t_core_element_hierarchy h1 ON ((h1.key_element = co.fk_variable)))
           LEFT JOIN common_dd.t_core_element_hierarchy h2 ON ((h2.key_element = co.fk_variable2)))
        WHERE ((COALESCE((l.valid_until)::timestamp with time zone, now()) >= now()) AND (COALESCE((l.valid_from)::timestamp with time zone, now()) <= now()))
        GROUP BY l.fk_variable, ty.logictype_descr, l.fk_orgrp, co.fk_andgrp;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_logiccond</code> table
     * reference
     */
    public VDataquierLogiccond(String alias) {
        this(DSL.name(alias), V_DATAQUIER_LOGICCOND);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier_logiccond</code> table
     * reference
     */
    public VDataquierLogiccond(Name alias) {
        this(alias, V_DATAQUIER_LOGICCOND);
    }

    /**
     * Create a <code>common_dd.v_dataquier_logiccond</code> table reference
     */
    public VDataquierLogiccond() {
        this(DSL.name("v_dataquier_logiccond"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquierLogiccond as(String alias) {
        return new VDataquierLogiccond(DSL.name(alias), this);
    }

    @Override
    public VDataquierLogiccond as(Name alias) {
        return new VDataquierLogiccond(alias, this);
    }

    @Override
    public VDataquierLogiccond as(Table<?> alias) {
        return new VDataquierLogiccond(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierLogiccond rename(String name) {
        return new VDataquierLogiccond(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierLogiccond rename(Name name) {
        return new VDataquierLogiccond(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquierLogiccond rename(Table<?> name) {
        return new VDataquierLogiccond(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogiccond where(Condition condition) {
        return new VDataquierLogiccond(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogiccond where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogiccond where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogiccond where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogiccond where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogiccond where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogiccond where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquierLogiccond where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogiccond whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquierLogiccond whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
